; ##############################################################################
; DKP_System Updater
;
; File:		DKP_System.au3
; Author:	Sammysnake of Ner'Zhul	 2005, 2006 Syndicate Systems
; Version: 0.37
; LAST UPDATED: Feb 15, 2005
;
; Description:	Downloads the process_dkp.php page and copies it to sqlvars.lua
; in the WoW/Interfaces/Addons/DKP_System directory. 
;
; ##############################################################################
; DKP_System License
;
; This program is free software; you can redistribute it and/or modify it under 
; the terms of the GNU General Public License as published by the Free Software 
; Foundation; either version 2 of the License, or (at your option) any later 
; version.
;
; This program is distributed in the hope that it will be useful, but WITHOUT 
; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
; details.
;
; You should have received a copy of the GNU General Public License along with 
; this program; if not, write to the Free Software Foundation, Inc., 675 Mass 
; Ave, Cambridge, MA 02139, USA.
;
; ##############################################################################
; ChangeLog (Read changelog.txt for more detailed history)
; (DKP_System Updater) Changed Location field to allow for custom output directory, default is ../Addons/DKP_System
; (DKP_System Updater) Added checkbox to limit history from updater, also lets you specify days to limit
; (DKP_System Updater) Added checkbox to filter inactive players, also lets you specify days of inactivity to limit
; (DKP_System Updater) Added checkbox that set updater to auto update when program first starts
; (DKP_System Updater) Added "Launch WoW" button
; (process_dkp.php) Revised to make provisions for new Updater features

#include <GuiConstants.au3>
#include <Date.au3>
If Not IsDeclared('WS_CLIPSIBLINGS') Then Global $WS_CLIPSIBLINGS = 0x04000000

FileInstall("C:\inst\logo.jpg", @TempDir & "\logo.jpg");

$version = "0.37";

;################################################################################
; GUI Design
;--------------------------------------------------------------------------------

$size_x = 335;
$size_y = 559;
$ctrl_gui_window = GuiCreate("DKP_System - Updater (Version " & $version & ")", $size_x, $size_y,(@DesktopWidth-$size_x)/2, (@DesktopHeight-$size_y)/2, $WS_SYSMENU + $WS_MINIMIZEBOX  )
GUISetBkColor (0xe0dfe3) 

;--------------------------------------------------------------------------------
; About
;--------------------------------------------------------------------------------


;GuiCtrlCreateLabel("DKP_System Updater", 10, 5, 327, 40 )
;GUICtrlSetColor(-1,0xff0000)    ; Red
$n=GUICtrlCreatePic( @TempDir & "\logo.jpg",0,5, 327,41)

$font="System"
GUISetFont (8, 800, 1, $font)   ; will display underlined characters

GuiCtrlCreateLabel("Programmed by Sammysnake aka synd][cate" & @CRLF & "Version " & $version , 10, 45, 320, 40)
GuiCtrlCreateLabel("Version " & $version & "  2005, 2006 Syndicate Systems", 10, 60, 320, 40)

; Set Font back to default
$font=""
GUISetFont (9, 400, 0, $font)   ; set characters back to reg


;--------------------------------------------------------------------------------
; Location Variables
;--------------------------------------------------------------------------------
$offset_y = 72;
GUICtrlCreateGroup ("Locations", 5, 1+$offset_y, 320, 170)
GuiCtrlCreateLabel("Location of Raidpoints PHP page", 10, 15+$offset_y, 210, 20)
$ctrl_path_phpdkp = GuiCtrlCreateInput("http://www.yourguildpage.com/process_dkp.php", 10, 30+$offset_y, 310, 20)

GUICtrlCreateGroup ("Results", 162, 50+$offset_y, 160, 92)
$ctrl_check_webpage = GuiCtrlCreateButton("Check Webpage Link", 10, 57+$offset_y, 150, 20)
$status_webpage = GuiCtrlCreateLabel("Name: <None>" & @CRLF & "Version: <None>" & @CRLF & "EQDKP Version: <None>" & @CRLF & "Players: <None>" & @CRLF & "Items: <None>" & @CRLF & "DKP Total: <None>" , 168, 61+$offset_y, 140, 80)

GUICtrlCreateGroup ("Status", 11, 78+$offset_y, 148, 32)
$status = GuiCtrlCreateLabel("IDLE", 20, 92+$offset_y, 135, 15)


$offset_y = 98;

;; << Credit >> Idea of reading registry for wow path goes to qir from curse-gaming.com 
$default_wowpath = RegRead ("HKEY_LOCAL_MACHINE\SOFTWARE\Blizzard Entertainment\World of Warcraft", "InstallPath")
$default_wowpath = $default_wowpath & "Interface\Addons\DKP_System\";
if (($default_wowpath == -1) or ($default_wowpath == -2)) then
		; No registry key exists, use default path
		$default_wowpath = "c:\Program Files\World of Warcraft\Interface\Addons\DKP_System\";
endif

GUISetFont (8, 400, 0, $font)
GuiCtrlCreateLabel("Location of DKP_System addon", 10, 105+$offset_y, 150, 20)
GUISetFont (9, 400, 0, $font)
$ctrl_path_wowpath = GuiCtrlCreateInput($default_wowpath, 10, 120+$offset_y, 225, 20)
$browse_wow_path = GuiCtrlCreateButton("Browse", 237, 120+$offset_y, 83, 20)

;--------------------------------------------------------------------------------
; Operation Buttons
;--------------------------------------------------------------------------------
$offset_y = 92;
GUICtrlCreateGroup ("Operation", 5, 155+$offset_y, 320, 98)
$ctrl_update_variables = GuiCtrlCreateButton("Load DKP_System Variables", 10, 170+$offset_y, 150, 20)
$ctrl_update_on = GuiCtrlCreateButton("Auto Update [OFF]", 168, 170+$offset_y, 150, 20)

$ani1 = GUICtrlCreateAvi (@SystemDir & "\shell32.dll",170, 32,190+$offset_y, 10, 10)


;--------------------------------------------------------------------------------
; Setup Buttons
;--------------------------------------------------------------------------------

$offset_y = 157;
GUICtrlCreateGroup ("Setup", 5, 195+$offset_y, 320, 146)

$offset_y = 175;
$ctrl_radio_updatestartup = GUICtrlCreateCheckbox ("Update on Startup........", 19, 190+$offset_y, 130, 20)
$ctrl_radio_autoupdatestartup = GUICtrlCreateCheckbox ("Auto-Update", 149, 190+$offset_y, 105, 20)
$ctrl_radio_launchwow = GUICtrlCreateCheckbox ("Launch WoW after update", 19, 207+$offset_y, 150, 20)


$offset_y = 194;
;Update Mode Setup
;GUICtrlCreateGroup ("DKP Update Mode", 12, 210+$offset_y, 295, 37)

;GUIStartGroup()
;$ctrl_radio_um_consolereload = GUICtrlCreateRadio ("/console reloadui", 25, 225+$offset_y, 120, 20)
;$ctrl_radio_um_realtime = GUICtrlCreateRadio ("Real-Time*", 150, 225+$offset_y, 120, 20)

GUICtrlCreateGroup ("Filter Inactive Players", 12, 208+$offset_y, 165, 38)
$ctrl_input_filterdays = GuiCtrlCreateInput("", 18, 221+$offset_y, 20, 20)
GuiCtrlCreateLabel("Days of Inactivity", 41, 225+$offset_y, 100, 15)
$ctrl_radio_filterinac = GUICtrlCreateCheckbox ("Enable", 124, 205+$offset_y, 50, 20)

GUICtrlCreateGroup ("Limit Raid History", 178, 208+$offset_y, 141, 38)
$ctrl_input_importdays = GuiCtrlCreateInput("", 185, 221+$offset_y, 20, 20)
GuiCtrlCreateLabel("Days to Import", 210, 225+$offset_y, 100, 15)
$ctrl_radio_limitraidhist = GUICtrlCreateCheckbox ("Enable", 272, 205+$offset_y, 50, 20)

$offset_y = 193;

;Sound Setup
GUICtrlCreateGroup ("Sound Alert", 12, 243+$offset_y, 307, 58)
$ctrl_enable_sound = GUICtrlCreateCheckbox ("Enable", 82, 240+$offset_y, 55, 20)

$offset_y = 186;
$ctrl_path_soundalert = GuiCtrlCreateInput(@WindowsDir & "\MEDIA\ALERT.WAV", 20, 280+$offset_y, 215, 20)
$ctrl_browse_sound_path = GuiCtrlCreateButton("Browse", 237, 280+$offset_y, 78, 20)
GuiCtrlCreateLabel("Note: Plays when changes are made to the Raid Points", 20, 265+$offset_y, 280, 15)

;--------------------------------------------------------------------------------
; System Buttons
;--------------------------------------------------------------------------------
$offset_y = 171;
$ctrl_launch = GuiCtrlCreateButton("Launch WoW", 230, 330+$offset_y, 95, 23)
$ctrl_close = GuiCtrlCreateButton("Close", 6, 330+$offset_y, 95, 23)

;--------------------------------------------------------------------------------
; End of GUI Design
;################################################################################


; Load INI Values

;---------------------------------------
; (Load Value) Sound Enabled Option
;----------------------------------------
$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "soundenabled", "4");
if ($var == 4) Then
	GUICtrlSetState($ctrl_enable_sound, $GUI_UNCHECKED);
Else
	GUICtrlSetState($ctrl_enable_sound, $GUI_CHECKED);
EndIf

;---------------------------------------
; (Load Value) Sound Path
;----------------------------------------
$path_sound = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "sound", @WindowsDir & "\MEDIA\ALERT.WAV");
GUICtrlSetData ( $ctrl_path_soundalert, $path_sound );

;---------------------------------------
; (Load Value) Filter Inactivity 
;----------------------------------------
$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "filterinactive", "4");
if ($var == 4) Then
	GUICtrlSetState($ctrl_radio_filterinac, $GUI_UNCHECKED);
	GUICtrlSetState( $ctrl_input_filterdays, $GUI_DISABLE )
Else
	GUICtrlSetState($ctrl_radio_filterinac, $GUI_CHECKED);
EndIf

;---------------------------------------
; (Load Value) Filiter Inactivity Days
;----------------------------------------

$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "days_filterinactive", "30");
GUICtrlSetData ( $ctrl_input_filterdays, $var );

;---------------------------------------
; (Load Value) Limit Raid History
;----------------------------------------
$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "limit_raidhistory", "4");
if ($var == 4) Then
	GUICtrlSetState($ctrl_radio_limitraidhist, $GUI_UNCHECKED);
	GUICtrlSetState ( $ctrl_input_importdays, $GUI_DISABLE )
Else
	GUICtrlSetState($ctrl_radio_limitraidhist, $GUI_CHECKED);
EndIf

;---------------------------------------
; (Load Value) Filiter Inactivity Days
;----------------------------------------

$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "days_raidhistory", "15");
GUICtrlSetData ( $ctrl_input_importdays, $var );

;---------------------------------------
; (Load Value) Auto-Update on Startup
;----------------------------------------
$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "autoupdatestartup", "4");
if ($var == 4) Then
	GUICtrlSetState($ctrl_radio_autoupdatestartup, $GUI_UNCHECKED);
	$startup_autoupdate = 0;
Else
	GUICtrlSetState($ctrl_radio_autoupdatestartup, $GUI_CHECKED);
	$startup_autoupdate = 1;
EndIf

;---------------------------------------
; (Load Value) Update on Startup
;----------------------------------------
$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "updatestartup", "4");
if ($var == 4) Then
	GUICtrlSetState($ctrl_radio_updatestartup, $GUI_UNCHECKED);
	GUICtrlSetState ( $ctrl_radio_autoupdatestartup, $GUI_DISABLE )		
	$startup_update = 0;			
Else
	GUICtrlSetState($ctrl_radio_updatestartup, $GUI_CHECKED);
	$startup_update = 1;
	if ($startup_autoupdate == 1) Then
			$update_on = 1;
			GUICtrlSetState ($ani1, 1)
			GUICtrlSetData ( $ctrl_update_on, "Auto Update [ON]" );	
			GUICtrlSetData ( $status, "Initalizing Auto-Update" );	
	EndIf
	
EndIf

;---------------------------------------
; (Load Value) Launch Wow on Load
;----------------------------------------
$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "launchwow", "4");
if ($var == 4) Then
	GUICtrlSetState($ctrl_radio_launchwow, $GUI_UNCHECKED);
Else
	GUICtrlSetState($ctrl_radio_launchwow , $GUI_CHECKED);
EndIf

;---------------------------------------
; (Load Value) Path to PHP
;----------------------------------------

$var = IniRead(@WindowsDir & "\load_dkp.ini", "path", "phpdkp", "http://www.yourguildpage.com/process_dkp.php");
GUICtrlSetData ( $ctrl_path_phpdkp, $var );

;---------------------------------------
; (Load Value) Path to Addon
;----------------------------------------

$path_wowpath = IniRead(@WindowsDir & "\load_dkp.ini", "path", "saveluapath", $default_wowpath);
GUICtrlSetData ( $ctrl_path_wowpath, $path_wowpath );


;--- Read ini settings - Update mode

;$updatemode_dkp = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "updatedkpmode", "reloadconsole");
;if ($updatemode_dkp == "reloadconsole") Then
;		GUICtrlSetState($ctrl_radio_um_consolereload, $GUI_CHECKED)
;elseif ($updatemode_dkp == "realtime") Then
;		GUICtrlSetState($ctrl_radio_um_realtime, $GUI_CHECKED)
;else
;		GUICtrlSetState($ctrl_radio_um_consolereload, $GUI_CHECKED)
;EndIf

;--------------------------------------------------------------------------------

$update_on = 0;
$update_timer = 0;
$current_points = 0;
$old_points = -999;
$old_items = -999;
$t_old = "";


GuiSetState()
While 1
	$update_php = 1;	
	$update_php = 0;
	$msg = GuiGetMsg()	
	
	if (NOT $update_timer) Then
			$update_timer = TimerInit();
	Else
			$dif = TimerDiff($update_timer)
				
			if ($dif > 10000) Then
					$update_php = 1;
					$update_timer = 0;
			EndIf
	EndIf 
	
	if (($update_php and $update_on) OR ($msg == $ctrl_update_variables) OR ($startup_update)) Then
		$nfo_name = "";
		$nfo_version = "";
		$nfo_eqdkp_version = "";
		$nfo_members = "";
		$nfo_items = "";
		$nfo_points = 0;
		$nfo_page = "";
		$error = 0;
		$forced_update = 0;
		
		if ($msg == $ctrl_update_variables) Then
				$forced_update = 1;
		EndIf

		$days_raidhistory = GUICtrlRead($ctrl_input_importdays);
		$days_filterinact = GUICtrlRead($ctrl_input_filterdays);		
		$tmp_finact = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "filterinactive", "4");
		$tmp_lrh = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "limit_raidhistory", "4");
		
		$results = Download_ProcessDkp("get_current_dkp", $tmp_finact, $days_filterinact, $tmp_lrh, $days_raidhistory, $nfo_name, $nfo_version, $nfo_eqdkp_version, $nfo_members, $nfo_items, $nfo_points, $nfo_page);		
		If ($results == 1) Then
				GUICtrlSetData ( $status_webpage, "Name: " & $nfo_name & @CRLF & "Version: " & $nfo_version & "    " & $nfo_page & @CRLF & "EQDKP Version:" & $nfo_eqdkp_version & @CRLF & "Players: " & $nfo_members & @CRLF & "Items: " & $nfo_items & @CRLF & "DKP Total:" & $nfo_points);
		Else
				MsgBox(0, "Error", "Download Error: Click on 'Check Webpage Link' for more information on this error!");
				$error = 1;
		EndIf
				
		; Check if points have changed since last time we checked			
		if ( ( (($old_points <> $nfo_points) or ($old_items <> $nfo_items)) and (not $error)) or ($forced_update) or ($startup_update) ) Then
				
				$startup_update = 0;
				
				$old_points = $nfo_points;																	
				$old_items = $nfo_items;													
				
				; Since we have change in dkp, download full sql file 
				GUICtrlSetData ( $status, "Downloading sqlvars.lua ..." );
		
				$days_raidhistory = GUICtrlRead($ctrl_input_importdays);
				$days_filterinact = GUICtrlRead($ctrl_input_filterdays);		
				$tmp_finact = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "filterinactive", "4");
				$tmp_lrh = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "limit_raidhistory", "4");
								
				$results = Download_ProcessDkp("get_sqlvars", $tmp_finact, $days_filterinact, $tmp_lrh, $days_raidhistory, $nfo_name, $nfo_version, $nfo_eqdkp_version, $nfo_members, $nfo_items, $nfo_points, $nfo_page);					
						
				If ($results == 1) Then
						GUICtrlSetData ( $status_webpage, "Name: " & $nfo_name & @CRLF & "Version: " & $nfo_version & "    " & $nfo_page & @CRLF & "EQDKP Version:" & $nfo_eqdkp_version & @CRLF & "Players: " & $nfo_members & @CRLF & "Items: " & $nfo_items & @CRLF & "DKP Total:" & $nfo_points);
				Else
						MsgBox(0, "Error", "Download Error: Click on 'Check Webpage Link' for more information on this error!");
				EndIf				
				
				$path = GUICtrlRead($ctrl_path_soundalert);
				$var = GUICtrlRead($ctrl_enable_sound);
				if ($var == 1) Then
					SoundPlay($path);	
				EndIf				
				
				; Copy processDKP.txt to sqlvars.lua
				Update_SQL_Vars();
				
				$var = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "launchwow", "4");
				if (($var == 1) and NOT WinExists ("World of Warcraft")) then
						$default_wowpath = RegRead ("HKEY_LOCAL_MACHINE\SOFTWARE\Blizzard Entertainment\World of Warcraft", "InstallPath")
						Run($default_wowpath & "\wow.exe");
				EndIf
		EndIf		
	EndIf
	
	Select
			Case $msg = $GUI_EVENT_CLOSE
					ExitLoop
			Case $msg = $ctrl_close
					ExitLoop		
			Case $msg = $ctrl_launch
					$default_wowpath = RegRead ("HKEY_LOCAL_MACHINE\SOFTWARE\Blizzard Entertainment\World of Warcraft", "InstallPath")
					Run($default_wowpath & "\wow.exe");			
			Case $msg = $ctrl_check_webpage
					; -------------------------------------------------
					; Webpage Link Check
					; -------------------------------------------------						
						
					$nfo_name = "";
					$nfo_version = "";
					$nfo_eqdkp_version = "";
					$nfo_members = "";
					$nfo_items = "";
					$nfo_points = 0;
					$nfo_page = "";

					GUICtrlSetData ( $status, "Checking Webpage Link ..." );

					$days_raidhistory = GUICtrlRead($ctrl_input_importdays);
					$days_filterinact = GUICtrlRead($ctrl_input_filterdays);				
					$tmp_finact = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "filterinactive", "4");
					$tmp_lrh = IniRead(@WindowsDir & "\load_dkp.ini", "setup", "limit_raidhistory", "4");
												
					$results = Download_ProcessDkp("get_current_dkp", $tmp_finact, $days_filterinact, $tmp_lrh, $days_raidhistory, $nfo_name, $nfo_version, $nfo_eqdkp_version, $nfo_members, $nfo_items, $nfo_points, $nfo_page);					
					
					if ($results == 1) Then					
							GUICtrlSetData ( $status, "Success!!" );
							GUICtrlSetData ( $status_webpage, "Name: " & $nfo_name & @CRLF & "Version: " & $nfo_version & "    " & $nfo_page & @CRLF & "EQDKP Version:" & $nfo_eqdkp_version & @CRLF & "Players: " & $nfo_members & @CRLF & "Items: " & $nfo_items & @CRLF & "DKP Total:" & $nfo_points);
							
							if ($nfo_version == $version) Then
									; Versions match
							ElseIf ($nfo_version > $version) Then									 
									MsgBox(0,"Error", "Warning: DKP_System Updater is out-of-date, process_dkp.php version is greater."  & @CRLF & @CRLF & "For the latest version please visit the following link:" & @CRLF & "http://www.curse-gaming.com/mod.php?addid=1292");																
							ElseIf ($nfo_version < $version) Then
									;Doesn't matter that DKP_System is newer
									;MsgBox(0,"Error", "Warning: process_dkp.php is out-of-date, DKP_System Updater version is greater."  & @CRLF & @CRLF & "For the latest version please visit the following link:" & @CRLF & "http://www.curse-gaming.com/mod.php?addid=1292");
							EndIf
					ElseIf ($results == 0) Then
							MsgBox(0, "Error", "Error: process_dkp.php is either either an old version or doesn't exist!" & @CRLF & @CRLF & "Please check the contents of C:\windows\processDKP.txt and ensure it doesn't contain an webpage error message!");
							GUICtrlSetData ( $status, "Error: Webpage Link" );
					ElseIf ($results == -1) Then
							MsgBox(0, "Error", "Error: Error downloading process_dkp.php page, check your internet connection!");
							GUICtrlSetData ( $status, "Error: Webpage Link" );
					Else
							MsgBox(0, "Error", "Unkown Error: Tell me if you see this!");
					EndIf			
					
					sleep(1000);
					GUICtrlSetData ( $status, "IDLE" );					
					
;			Case $msg = $ctrl_radio_um_realtime
					; -------------------------------------------------
					; [setup] (radio) Set update mode -> real-mode
					; -------------------------------------------------			
					
;					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "updatedkpmode", "realmode");
				
;			Case $msg = $ctrl_radio_um_consolereload
					; -------------------------------------------------
					; [setup] (radio) Set update mode -> /reload console
					; -------------------------------------------------			
				
;					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "updatedkpmode", "reloadconsole");
					
			Case $msg = $ctrl_enable_sound
					; -------------------------------------------------
					; [setup] (checkbox) Enabled Sound
					; -------------------------------------------------
			
					$var = GUICtrlRead($ctrl_enable_sound);
					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "soundenabled", $var);

			Case $msg = $ctrl_radio_filterinac
					; -------------------------------------------------
					; [setup] (checkbox) Filter Inactive Players
					; -------------------------------------------------
			
					$var = GUICtrlRead($ctrl_radio_filterinac);
					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "filterinactive", $var);
					
					if ($var == 4) Then
							GUICtrlSetState ( $ctrl_input_filterdays, $GUI_DISABLE )
					Else
							GUICtrlSetState ( $ctrl_input_filterdays, $GUI_ENABLE )
					EndIf					
					
			Case $msg = $ctrl_radio_limitraidhist
					; -------------------------------------------------
					; [setup] (checkbox) Limit Raid History
					; -------------------------------------------------

					$var = GUICtrlRead($ctrl_radio_limitraidhist);
					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "limit_raidhistory", $var);
					
					if ($var == 4) Then
							GUICtrlSetState ( $ctrl_input_importdays, $GUI_DISABLE )
					Else
							GUICtrlSetState ( $ctrl_input_importdays, $GUI_ENABLE )
					EndIf					

			Case $msg = $ctrl_radio_updatestartup
					; -------------------------------------------------
					; [setup] (checkbox) Update on Startup
					; -------------------------------------------------
			
					$var = GUICtrlRead($ctrl_radio_updatestartup);
					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "updatestartup", $var);
					
					if ($var == 4) Then
							GUICtrlSetState ( $ctrl_radio_autoupdatestartup, $GUI_DISABLE )
					Else
							GUICtrlSetState ( $ctrl_radio_autoupdatestartup, $GUI_ENABLE )
					EndIf
					
			Case $msg = $ctrl_radio_autoupdatestartup
					; -------------------------------------------------
					; [setup] (checkbox) Auto-Update on Startup
					; -------------------------------------------------
			
					$var = GUICtrlRead($ctrl_radio_autoupdatestartup);
					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "autoupdatestartup", $var);															
					
			Case $msg = $ctrl_radio_launchwow 
					; -------------------------------------------------
					; [setup] (checkbox) Launch WoW
					; -------------------------------------------------

					$var = GUICtrlRead($ctrl_radio_launchwow);
					IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "launchwow", $var);					
					

			Case $msg = $ctrl_update_on
					; -------------------------------------------------
					; Toggle Auto-Update
					; -------------------------------------------------				
					If ($update_on) Then
						$update_on = 0;
						GUICtrlSetState ($ani1, 0)
						GUICtrlSetData ( $ctrl_update_on, "Auto Update [OFF]" );
						GUICtrlSetData ( $status, "IDLE" );	
					Else
						$update_on = 1;
						GUICtrlSetState ($ani1, 1)
						GUICtrlSetData ( $ctrl_update_on, "Auto Update [ON]" );	
						GUICtrlSetData ( $status, "Initalizing Auto-Update" );
					EndIf							
					
			Case $msg = $ctrl_browse_sound_path
					; -------------------------------------------------
					; Browse Sound Path
					; -------------------------------------------------
			
					; Open browse window for sound path
					Browse_Sound_Path();
											
			Case $msg = $browse_wow_path		
					; -------------------------------------------------
					; Browse Wow Path
					; -------------------------------------------------
			
					; Open browse window for WoW path
					Browse_WoW_Path();
				
			Case $msg = $ctrl_update_variables
					; Create / Update sqlvars.lua
					; Update_SQL_Vars();
			Case Else
				;;;
	EndSelect
WEnd
Exit	; End of Main

;;; Function ;;;;;;;;;;;;;;;;;;;;;;;
;;; int Update_SQL_Vars ();
;
;;;	Parameters: 	[byRef] $name: page name
;;;
;;; Returns: 	Success: Returns 1. 
;;;						Failure: Returns 0. 

Func Update_SQL_Vars ()
		
		;Get paths to process_dkp.php & WoW
		$path_phpdkp = GUICtrlRead($ctrl_path_phpdkp);
		IniWrite(@WindowsDir & "\load_dkp.ini", "path", "phpdkp", $path_phpdkp);
		$path_wowpath = GUICtrlRead($ctrl_path_wowpath);
		IniWrite(@WindowsDir & "\load_dkp.ini", "path", "saveluapath", $path_wowpath);					
		
		$var = GUICtrlRead($ctrl_input_importdays);
		IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "days_raidhistory", $var);			
		$var = GUICtrlRead($ctrl_input_filterdays);
		IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "days_filterinactive", $var);	
		
		$write_location = $path_wowpath & "sqlvars.lua";
		$result = FileCopy ( @WindowsDir & "\processDKP.txt", $write_location, 1);
		
		If ($result == 0) then
				MsgBox(0, "Error", "Error: There was a problem copying.." & @CRLF & @WindowsDir & "\processDKP.txt" & @CRLF & "to.." & @CRLF & $write_location); 
		Else
				GUICtrlSetData ( $status, "Copying processDKP.txt to sqlvars.lua.." );
				sleep(1000);		
				GUICtrlSetData ( $status, "IDLE" );			
		EndIf
				
EndFunc


;;; Function ;;;;;;;;;;;;;;;;;;;;;;;
;;; int Download_ProcessDkp ();
;
;;;	Parameters: 	$page_request : "get_sqlvars" / "get_current_dkp" - download full sqlvars.lua or summary
;;;								$filter_inactive : 4 - false, 1-true
;;;								$filter_days		 : (int) # of days to filter 
;;;								$limit_history	 : 4 - false, 1-true
;;;								$limit_days			 : (int) # of days to limit
;;;								[byRef] $ref_name: page name
;;;								[byRef] $ref_version: page version
;;;								[byRef] $ref_eqdkp_version: version of eqdkp
;;;								[byRef] $ref_members: number of members
;;;								[byRef] $ref_items:	number of items
;;;								[byRef] $ref_points: sum of total points
;;;								[byRef] $ref_page: page returned
;;;
;;; Returns: 	Success: Returns 1. 
;;;						Failure: Returns 0. 


Func Download_ProcessDkp ( $page_request, $filter_inactive, $filter_days, $limit_history, $limit_days, ByRef $ref_name, ByRef $ref_version, ByRef $ref_eqdkp_version, ByRef $ref_players, ByRef $ref_items, ByRef $ref_points, ByRef $ref_page)

		; Save current path to Webpage
		$path_phpdkp = GUICtrlRead($ctrl_path_phpdkp);
		IniWrite(@WindowsDir & "\load_dkp.ini", "path", "phpdkp", $path_phpdkp);

		$file_valid = 0;
		
		; Things to check
		$check_name = 0;
		$check_page = "";
		$check_version = 0;
		$check_member_listings = 0;
		$check_item_listings = 0;
		
		; Variables for counting members / items
		$process_members = 0;
		$ref_players = 0;
		
		$process_items = 0;
		$ref_items = 0;

		; Download current points
		$result = InetGet($path_phpdkp & "?page=" & $page_request & "&" & "f=" & $filter_inactive & "&" & "fdays=" & $filter_days & "&" & "l=" & $limit_history & "&" & "ldays=" & $limit_days, @WindowsDir & "\processDKP.txt", 1, 0);
		
		If ($result = 0) Then
				; Error downloading the webpage (internet problem)
		    return -1;
		EndIf		
		
		$file_processDKP = FileOpen(@WindowsDir & "\processDKP.txt", 0);
		
		While 1
				$line = FileReadLine($file_processDKP);				
				If @error = -1 Then ExitLoop
				
				$dkp_info = StringSplit($line, ":");
				
				If (($dkp_info[0] == 3) and ( StringInStr($dkp_info[1], "--NFO")) ) Then
						; Correctly delimited tag has 3 values
												
						If ($dkp_info[2] == "NAME") Then
								$check_name = 1;				
								$ref_name = $dkp_info[3];
						ElseIf ($dkp_info[2] == "VERSION") Then
								$check_version = 1;										
								$ref_version = $dkp_info[3];
						ElseIf ($dkp_info[2] == "EQDKP_VERSION") Then					
								$ref_eqdkp_version = $dkp_info[3];
						ElseIf ($dkp_info[2] == "PLAYERS") Then
								$ref_players = $dkp_info[3];
						ElseIf ($dkp_info[2] == "ITEMS") Then
								$ref_items = $dkp_info[3];
						ElseIf ($dkp_info[2] == "POINTS") Then						
								$ref_points = $dkp_info[3];
						ElseIf ($dkp_info[2] == "PAGE") Then
								$ref_page = $dkp_info[3];
						EndIf				
				EndIf
		WEnd
		
		FileClose($file_processDKP);
		
		If ($check_name and $check_version) Then
				$file_valid = 1;
		Else
				$file_valid = 0;
		EndIf
		
		Return $file_valid;

EndFunc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Browse Functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Function ;;;;;;;;;;;;;;;;;;;;;;;
;;; int Browse_WoW_Path ();
;
;;;	args: none
;;; returns: none
;


Func Browse_WoW_Path ()

		$path_correct = 0;
		

		$var = FileSelectFolder("Selected path to World of Warcraft", "", 4)				
		
		If ($var == "") Then
				; Since Dialog Window was closed, try and use the default location				
				$var= RegRead ("HKEY_LOCAL_MACHINE\SOFTWARE\Blizzard Entertainment\World of Warcraft", "InstallPath")
				$var = $var & "Interface\Addons\DKP_System";				
				
				; Incorrect Path
				MsgBox(4096, "ERROR", "Dialog Box Cancled.." & @CRLF & "Error: Defaulting to WoW path designated in registry!")
		EndIf
		
		$var = $var & "\";
		GUICtrlSetData ( $ctrl_path_wowpath, $var );	
		IniWrite(@WindowsDir & "\load_dkp.ini", "path", "saveluapath", $var);

EndFunc		

;;; Function ;;;;;;;;;;;;;;;;;;;;;;;
;;; int Browse_Sound_Path ();
;
;;;	args: none
;;; returns: none
;

Func Browse_Sound_Path ()		
		$var = FileSaveDialog( "Choose a sound file to play", @WindowsDir & "\MEDIA\" , "Sound Files (*.wav;*.mp3)", 3)
		
		if ($var == 1) Then
				; Browse window was cancled, set to default.
				$var = @WindowsDir & "\MEDIA\ALERT.WAV";
		EndIf
		
		GUICtrlSetData ( $ctrl_path_soundalert, $var );	
		SoundPlay($var);	
		
		IniWrite(@WindowsDir & "\load_dkp.ini", "setup", "sound", $var);		
EndFunc

