--------------------------------------------------
-- 		
--		Addon: AutoRez
-- 		Date: 6/4/05
--		Author: Blama
--		Beta Tester: Vindicator		Realm: Ner'zhul
--		Contact: darkforce898@gmail.com
-- 
--------------------------------------------------

local AutoRez_Color = "|c000566FF";
local AutoRez_CurVer = "0.2";

function AutoRez_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("RESURRECT_REQUEST");
	this:RegisterEvent("CONFIRM_SUMMON");
end 

function AutoRez_OnEvent(event)
	if ( event == "VARIABLES_LOADED" ) then
		AutoRez_Load();
	end
		
	if ( event == "RESURRECT_REQUEST" ) then
		AutoRez_Resurrect();
	end
	
	if ( event == "CONFIRM_SUMMON" ) then
		AutoRez_Summon();
	end
end

function AutoRez_Load()
	AutoRez_Chat("AutoRessurect v"..AutoRez_CurVer.." loaded.");
	
	SLASH_AutoRez1 = "/autorez";
	SlashCmdList["AutoRez"] = function(msg)
		AutoRez_HandleSlashes(msg);
	end
	
	if ( AutoRez_Save == nil ) then
		AutoRez_Save = {};
		AutoRez_Save.version = AutoRez_CurVer;
		AutoRez_Save.rezenabled = true;
		Autorez_Save.summonenabled = true;
	end
end

function AutoRez_Resurrect()
	if ( AutoRez_Save.rezenabled ) then
		AcceptResurrect();
	else
		AutoRez_Chat("Auto Resurrect is set to off. Not resurrecting. Type \"/autorez reztoggle\" to change this.");
	end
end

function AutoRez_Summon()
	if ( AutoRez_Save.summonenabled ) then
		ConfirmSummon();
	else
		AutoRez_Chat("Auto Summon is set to off. Not accepting summon. Type \"/autorez summontoggle\" to change this.");
	end
end

function AutoRez_Chat(text)
	DEFAULT_CHAT_FRAME:AddMessage(AutoRez_Color..text);	
end

function AutoRez_HandleSlashes(msg)
	if ( msg ) then
		msg = string.lower(msg);
	end
	
	if (msg == "summontoggle") then 
		AutoRez_SummonToggle();
	elseif (msg == "reztoggle") then
		AutoRez_RezToggle();
	else
		AutoRez_Chat("The Options for Auto Ressurect v" ..AutoRez_CurVer.. " are:");
		AutoRez_Chat("/autorez summontoggle : Toggles accepting resurrections on/off.");
		AutoRez_Chat("/autorez reztoggle : Toggles accepting summons on/off.");
		AutoRez_Chat("/autorez help : Shows this help message.");
	end
end

function AutoRez_RezToggle()
	if ( AutoRez_Save.rezenabled ) then
		AutoRez_Save.rezenabled = false;
		AutoRez_Chat("Auto Ressurect has been disabled. Type /autorez reztoggle to turn it back on.");
	else
		AutoRez_Save.rezenabled = true;
		AutoRez_Chat("Auto Ressurect has been enabled. Type /autorez reztoggle to turn it off.");
	end
end

function AutoRez_SummonToggle()
	if ( AutoRez_Save.summonenabled ) then
		AutoRez_Save.summonenabled = false;
		AutoRez_Chat("Auto Summon has been disabled. Type /autorez summontoggle to turn it back on.");
	else
		AutoRez_Save.summonenabled = true;
		AutoRez_Chat("Auto Summon has been enabled. Type /autorez summontoggle to turn it off.");
	end
end