--=============================================================================
-- File:		DKP_System_GUI.lua
-- Author:	Sammysnake of Ner'Zhul	 2004, 2005 Syndicate Systems
-- Description:	GUI Functions for the DKP_System Addon
--
-- Created: July, 17, 2005
-- Modified: July, 19, 2005
--=============================================================================

-- Declard color codes for console messages
local RED     = "|cffff0000";
local GREEN   = "|cff00ff00";
local BLUE    = "|cff0000ff";
local MAGENTA = "|cffff00ff";
local YELLOW  = "|cffffff00";
local CYAN    = "|cff00ffff";
local WHITE   = "|cffffffff";

-- ############################################################################################
-- ## Interface Functions 


local CT_CPTabs = {
	{ "Configuration", "Configuration", "Interface\\Icons\\Spell_Shadow_SoulGem" },
	{ "Hotbar Mods", "DKP Admin", "Interface\\Icons\\Ability_Rogue_SliceDice" },
	{ "Party Mods", "Activity Log", "Interface\\Icons\\Spell_Nature_Invisibilty" },
	{ "Player Mods", "Player Mods", "Interface\\Icons\\Ability_Warrior_Revenge" },
	{ "Misc. Mods", "Misc. Mods", "Interface\\Icons\\Spell_Frost_Stun" }
};

local toggled = 1;
------------------------
-- General GUI Functions

function DKP_System_GUI_Refresh()
	local currentID = UIDropDownMenu_GetSelectedID(DKPSYS_AuctionModeDropDown);
end

function DKP_System_GUI_TogglePullDownVisibility()
	if( not DKPS_FramePullDown:IsVisible() )then
			DKPS_FramePullDown:Show();
	else
			DKPS_FramePullDown:Hide();
	end
end


function DKP_System_GUI_ToggleVisibility()
	if( not DKPS_FrameHeader:IsVisible() )then
			DKPS_FrameHeader:Show();
			DKP_ROLL_Config.GUIOpen = true;
	else
			DKPS_FrameHeader:Hide();
			DKP_ROLL_Config.GUIOpen = false;
	end
end

function DKP_System_GUI_Hide()
	if( DKPS_PullDownFrame:IsVisible() )then
		DKPS_FramePullDown:Hide();
	end
end

function DKP_System_GUI_Parent_OnDragStart()		
	
	DKPS_FrameHeader:StartMoving();
	--bBeingDragged = true;	
	
end


function DKP_System_GUI_Parent_OnDragStop()
	
	DKPS_FrameHeader:StopMovingOrSizing();
	--bBeingDragged = false;
	
end

function DKP_System_GUI_OnUpdate(arg1)

end

function DKP_System_GUI_OnEvent()

end


function DKPSYS_CPSetTab(id)
	DEFAULT_CHAT_FRAME:AddMessage(this:GetID());
	
	for i = 1, 3, 1 do
		if (i == id) then
				getglobal("DKPSYS_CPTabButton".. i):Disable();
		else
			getglobal("DKPSYS_CPTabButton".. i):Enable();
		end
	end
	
	--getglobal("DKPSYS_CPTabButton1"):SetDisabledTexture();	


end

-------------------------------
-- Item Widget Pulldown 


function DKPSystem_GUI_Items_OnLoad()
	UIDropDownMenu_Initialize(this, DKPSystem_GUI_Items_LoadNames);			
	UIDropDownMenu_SetWidth(110);
	
end

ITEMS_DROPDOWN_LIST = {
		{ name = "No Items", linktext = "No Item Selected" }
};


function DKPSystem_GUI_Items_LoadNames()

	local info;

	for i = 1, getn(ITEMS_DROPDOWN_LIST), 1 do
		info = { };
		info.text = ITEMS_DROPDOWN_LIST[i].name;
		info.func = DKPSystem_GUI_Items_OnClick;
		UIDropDownMenu_AddButton(info);
	end
	
	UIDropDownMenu_SetText("Select Item", DKPSystem_GUI_ItemSelectDropDown);
	
	--local defaultName =  UIDropDownMenu_GetText(DKPSystem_GUI_Items_LoadNames);
	--UIDropDownMenu_SetSelectedValue(DKPSystem_GUI_Items_LoadNames, defaultName);	
	
	--local oldID = UIDropDownMenu_GetSelectedID(DKPSystem_GUI_ItemSelectDropDown);
	UIDropDownMenu_SetSelectedID(DKPSystem_GUI_ItemSelectDropDown, 1);
			
end

function DKPSystem_GUI_Items_OnClick()
		
	local oldID = UIDropDownMenu_GetSelectedID(DKPSystem_GUI_ItemSelectDropDown);
	local newID = this:GetID();
	
	UIDropDownMenu_SetSelectedID(DKPSystem_GUI_ItemSelectDropDown, this:GetID());
	if(oldID ~= this:GetID()) then
		--Atlas_Refresh();
		--DEFAULT_CHAT_FRAME:AddMessage(this:GetID());
		--DKP_ROLL_Config.System = AUCTION_MODES_DROPDOWN_LIST[newID].value;		
	end	
	
end



function DKP_System_Auction_Toggle ()
					
			local currentAuctionItem = UIDropDownMenu_GetSelectedID(DKPSystem_GUI_ItemSelectDropDown);					
					
			if (AuctionEnabled == true) then
					AuctionEnabled = false;
					DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_System: ".. WHITE .. "Auction ended for ".. ITEMS_DROPDOWN_LIST[currentAuctionItem].name);
					SendChatMessage("DKP_System: Auction has end for ".. ITEMS_DROPDOWN_LIST[currentAuctionItem].linktext , DKP_ROLL_Config.Announce_type );
					
					AuctionToggleButton:SetText("Start Auction");					
			else
					AuctionEnabled = true;					
					
					DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_System: ".. WHITE .. "Auction starting for ".. ITEMS_DROPDOWN_LIST[currentAuctionItem].name);
					SendChatMessage("DKP_System: Auction has started for ".. ITEMS_DROPDOWN_LIST[currentAuctionItem].linktext , DKP_ROLL_Config.Announce_type );
										
					AuctionList = {};
					Display_Bidders("GUI");					
					AuctionToggleButton:SetText("End Auction");
			end	
			
end			

-------------------------------
-- Auction Mode Widget Pulldown 

function DKPSYS_AuctionModeDropDown_OnShow()

		UIDropDownMenu_Initialize(this, DKPSYS_AuctionMode_LoadNames);		
		UIDropDownMenu_SetWidth(125);
		
	for i = 1, getn(DKPSYS_AUCTION_DROPDOWN_LIST), 1 do
			if (DKPSYS_AUCTION_DROPDOWN_LIST[i].value == DKP_ROLL_Config.System) then
					UIDropDownMenu_SetSelectedID(DKPSYS_AuctionModeDropDown, i);
					UIDropDownMenu_SetText(DKPSYS_AUCTION_DROPDOWN_LIST[i].name, DKPSYS_AuctionModeDropDown);
			end
	end						

end


function DKPSYS_AuctionMode_LoadNames()

	local info;
	for i = 1, getn(DKPSYS_AUCTION_DROPDOWN_LIST), 1 do
		info = { };
		info.text = DKPSYS_AUCTION_DROPDOWN_LIST[i].name;
		info.func = DKPSYS_AuctionModeDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
			
end

function DKPSYS_AuctionModeDropDown_OnClick()
		
	local oldID = UIDropDownMenu_GetSelectedID(DKPSYS_AuctionModeDropDown);
	local newID = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPSYS_AuctionModeDropDown, this:GetID());
	if(oldID ~= this:GetID()) then
		DKP_ROLL_Config.System = DKPSYS_AUCTION_DROPDOWN_LIST[newID].value;
	end	
	
end

function DKPSYS_AuctionModeDropDown_OnVariableLoaded() 

	for i = 1, getn(AUCTION_MODES_DROPDOWN_LIST), 1 do
			if (AUCTION_MODES_DROPDOWN_LIST[i].value == DKP_ROLL_Config.System) then
					UIDropDownMenu_SetSelectedID(DKPSYS_AuctionModeDropDown, i);
					UIDropDownMenu_SetText(AUCTION_MODES_DROPDOWN_LIST[i].name, DKPSYS_AuctionModeDropDown);
					--AuctionOptionsButton:SetText(AUCTION_MODES_DROPDOWN_LIST[i].shortname .. " Options");
			end
	end
		
end

-------------------------
-- Auction Options

function DKPSystemOptions_Toggle()
	if(DKPSystemOptionsFrame:IsVisible()) then
		DKPSystemOptionsFrame:Hide();
	else
		DKPSystemOptionsFrame:Show();
	end
end

function DKPSystemOptions_OnLoad()
	UIPanelWindows['DKPSystemOptionsFrame'] = {area = 'center', pushable = 0};
	
	for i = 1, 3, 1 do
		getglobal("DKPSYS_CPTabButton" .. i):SetText( CT_CPTabs[i][2]);
		getglobal("DKPSYS_CPTabButton" .. i).tooltiptext = CT_CPTabs[i][2];
	end	
	
	DKPSYS_CPTabButton1:Disable();
end


function DKPSystemOptions_OnShow()
end

function DKPSystemOptions_Init()

end

function DKPSystemOptions_OnHide()
	if(MYADDONS_ACTIVE_OPTIONSFRAME == this) then
		ShowUIPanel(myAddOnsFrame);
	end
end

-------------------------
-- Bidder List

function DKP_System_Bidder_OnClick ()
		local ID = this:GetID();
		DEFAULT_CHAT_FRAME:AddMessage(ID);
end