--
-- Alterac und Arathi Battleground Mods
--
-- based on v1.0 from LeoLeal,  thanks
-- modivied by Nitram to v1.1 with auto turn-In for alterac valley
--

LVBM.AddOns.Battlegrounds = { 
	["Name"] = "Alterac and Arathi Battlegrounds", 
	["Abbreviation1"] = "bg", 
	["Version"] = "1.1", 
	["Author"] = "LeoLeal", 
	["Description"] = "Shows timer bars for Alterac Valley and Arathi Basin flag captures. Enable auto turn-in's for Alterac Valley.", 
	["Instance"] = LVBM_OTHER, 
	["GUITab"] = LVBMGUI_TAB_OTHER, 
	["Sort"] = 0, 
	["Options"] = {
		["Enabled"] = true, 
		["Announce"] = true, 
		["AVAutoTurnIn"] = true, 
	}, 
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn", 
			["text"] = LVBM_BGMOD_LANG.AVTURNININFO, 
			["func"] = function() LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn = not LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn; end, 
		}, 
	}, 
	["Events"] = {
		["CHAT_MSG_MONSTER_YELL"] = true, 
		["CHAT_MSG_BG_SYSTEM_ALLIANCE"] = true, 
		["CHAT_MSG_BG_SYSTEM_HORDE"] = true, 
		["PLAYER_ENTERING_WORLD"] = true, 
		["GOSSIP_SHOW"] = true, 				-- Turn In
		["QUEST_PROGRESS"] = true, 			-- Turn In
		["QUEST_COMPLETE"] = true, 			-- Turn In
	}, 	
	["GetItemName"] = function(bag,  slot)
		local itemlink;
		if (bag == -1) then	itemlink = GetInventoryItemLink("player",  slot);
		else			itemlink = GetContainerItemLink(bag,  slot);
		end
		if (itemlink) then
			local _,  _,  name = string.find(itemlink,  "^.*%[(.*)%].*$");
			return name;
		else	return "";
		end
	end, 
	["GetItemCount"] = function(ItemName)
		local anzl,  bagNr,  bagSlot = 0;
		for bagNr = 0,  10,  1 do
			for bagSlot = 1,  GetContainerNumSlots(bagNr),  1 do
				if( LVBM.AddOns.Battlegrounds.GetItemName(bagNr,  bagSlot) == ItemName) then
					local _,  itemCount = GetContainerItemInfo(bagNr,  bagSlot);
					anzl = anzl + itemCount;
				end
			end
		end
		return anzl;
	end, 
	["OnEvent"] = function(event,  arg1)
		-- ---------------- --
		-- Code from Nitram --
		-- ---------------- --
		if ((event == "GOSSIP_SHOW" or event=="QUEST_PROGRESS") and GetZoneText() == LVBM_BGMOD_LANG.ZONE) then
			local target = UnitName("target");

			if( target == LVBM_BGMOD_LANG.NPC.SMITHREGZAR or target == LVBM_BGMOD_LANG.NPC.MURGOTDEEPFORGE ) then
				-- Open Quest to Smith or Murgot
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.ARMORSCRAPS) >= 20) then
					SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.PRIMALISTTHURLOGA) then
				local anzl = LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.SOLDIERSBLOOD);
				if (anzl >= 5) then		SelectGossipAvailableQuest(2);
				elseif (anzl > 0) then		SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.ARCHDRUIDRENFERAL) then
				local anzl = LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.STORMCRYSTAL);
				if (anzl >= 5) then		SelectGossipAvailableQuest(2);
				elseif (anzl > 0) then		SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.STORMPIKERAMRIDERCOMMANDER) then	-- Ram Riders
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.FROSTWOLFHIDE) > 0) then
					SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.FROSTWOLFWOLFRIDERCOMMANDER) then	-- Wolf Riders
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.ALTERACRAMHIDE) > 0) then
					SelectGossipAvailableQuest(1);
				end
			end

		end
		if (event=="QUEST_PROGRESS" and GetZoneText() == LVBM_BGMOD_LANG.ZONE) then
			local target = UnitName("target");

			if (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERJEZTOR 
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.LIEUTENANTSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERGUSE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.SOLDIERSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERMULVERICK
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.COMMANDERSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERVIPORE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.LIEUTENANTSMEDAL) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINDCOMMANDERSLIDORE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.SOLDIERSMEDAL) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERICHMAN
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.COMMANDERSMEDAL) == 0) then		return;

		   	end
			CompleteQuest();

		end
		if (event=="QUEST_COMPLETE" and GetZoneText() == LVBM_BGMOD_LANG.ZONE) then
			local target = UnitName("target");
			for index,  value in LVBM_BGMOD_LANG.NPC do
				if (target == value) then
					GetQuestReward(0);
					LVBM.AddMsg(LVBM_BGMOD_LANG.THANKS);
				end
			end
		end


		-- ----------------- --
		-- Code from LeoLeal --
		-- ----------------- --
		if (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE") then
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				if string.find(arg1, value) then
					if string.find(arg1, LVBM_BGMOD_LANG["HASASSAULTED"]) or string.find(arg1, LVBM_BGMOD_LANG["CLAIMSTHE"]) then
						--Initiate a timer w/ value as text string for 60 seconds
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.StartStatusBarTimer(63,  "Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
					elseif string.find(arg1, LVBM_BGMOD_LANG["HASDEFENDEDTHE"]) or string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
							LVBM.Announce("*** Alliance has taken the "..LVBM.Capitalize(LVBM_BGMOD_LANG.AB_TARGETS[index]).." ***");
						end
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
					end
				end
			end
		
			--Initial capture of Snowfall for horde
			if string.find(string.lower(arg1), string.lower(LVBM_BGMOD_EN_TARGET_AV[8])) then
				LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[8]);
				LVBM.StartStatusBarTimer(303,  "Alliance: "..LVBM_BGMOD_EN_TARGET_AV[8]);
			end
		elseif (event == "CHAT_MSG_MONSTER_YELL") then
			for index,  value in ipairs(LVBM_BGMOD_EN_TARGET_AV) do
				if string.find(string.lower(arg1), string.lower(value)) then
					if string.find(arg1, LVBM_BGMOD_LANG["UNDERATTACK"]) then
						--Initiate a timer w/ value as text string for 300 seconds
						if string.find(arg1, LVBM_BGMOD_LANG["HORDE"]) then 
							LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index]);
							LVBM.StartStatusBarTimer(303,  "Horde: "..LVBM_BGMOD_EN_TARGET_AV[index]);
						end
						if string.find(arg1, LVBM_BGMOD_LANG["ALLIANCE"]) then
							LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index]);
							LVBM.StartStatusBarTimer(303,  "Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index]);
						end
					elseif string.find(arg1, LVBM_BGMOD_LANG["BYTHE"]) or string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["ALLIANCE"]) then
							LVBM.Announce("*** Alliance has taken the "..value.." ***");
						end
						if string.find(arg1, LVBM_BGMOD_LANG["HORDE"]) then
							LVBM.Announce("*** Horde has taken the "..value.." ***");
						end
						LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index]);
						LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index]);
					end
				end
			
			end
		elseif (event == "CHAT_MSG_BG_SYSTEM_HORDE") then
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				if string.find(arg1, value) then
					if string.find(arg1, LVBM_BGMOD_LANG["HASASSAULTED"]) or string.find(arg1, LVBM_BGMOD_LANG["CLAIMSTHE"]) then
						--Initiate a timer w/ value as text string for 60 seconds
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.StartStatusBarTimer(63, "Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
					elseif string.find(arg1, LVBM_BGMOD_LANG["HASDEFENDEDTHE"]) or string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
							LVBM.Announce("*** Horde has taken the "..LVBM.Capitalize(LVBM_BGMOD_LANG.AB_TARGETS[index]).." ***");
						end
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
					end
				end
			end
		
			--Initial capture of Snowfall for horde
			if string.find(string.lower(arg1), string.lower(LVBM_BGMOD_EN_TARGET_AV[8])) then
				LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[8]);
				LVBM.StartStatusBarTimer(303, "Horde: "..LVBM_BGMOD_EN_TARGET_AV[8]);
			end
		elseif (event == "PLAYER_ENTERING_WORLD") then
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
				LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
			end
			for index, value in ipairs(LVBM_BGMOD_EN_TARGET_AV) do
				LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
				LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
			end
		end
	end, 		
};


-- Functions for BG Mods









